<?php
/*
* 06/26/2004 - 23:20:36
*
* saveload.php - Handles all of the file copy operations for creating new saved mapcycles or loading existing ones
* Copyright (C) 2004 Gregory Fowler
* hldstart@gamehound.net
* http://www.gamehound.net/~hldstart/
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
?>
<?php
      include('../config.php');
      include('../chk_login.php');      
      include('mapheader.php');
      include('../functions.php');
?>
<html>
 <head><title>Save/Load Map Cycles</title>
 <body>
<?php
//saveload.php - handles the save and load actions from fileadmin.php for the mapcycle.txt files
$filename = "$hlds_dir/$key/mapcycle.txt";

  //This section saves the current mapfile.txt to a filename specified
   if ($slaction == save) {
    #Make the savedmapcycles if it doesn't exist
     if (!is_dir("$hlds_dir/$key/savedmapcycles")){
       if (!mkdir("$hlds_dir/$key/savedmapcycles", 0777)){
         exit("Problem creating $hlds_dir/$key/savedmapcycles directory.  Check permissions.");
         }
   }
   // Let's make sure the file exists and is writable first.
     #Make sure the directory is writable
     if (!is_writable("$hlds_dir/$key/savedmapcycles")) {
         exit("Cannot write the saved file <b>$slname</b> to $hlds_dir/$key/savedmapcycles.  Check permissions on the directory");
        }
        #Copy the saved file into place
      if (!copy("$filename","$hlds_dir/$key/savedmapcycles/$savename.save")){
      echo "Unable to save mapcycle.txt"; 
	exit();
      }
    echo "Successfully saved the current mapcycle in $hlds_dir/$key/mapcycle.txt to $hlds_dir/$key/savedmapcyles/$savename.save";
    }
    //This section handles loading a previously saved mapcycle
    if ($slaction == load) {
       if (!is_dir("$hlds_dir/$key/savedmapcycles")){
         exit("Can't find the $hlds_dir/$key/savedmapcycles directory");
         }
       if (!is_writable("$hlds_dir/$key/mapcycle.txt")){
         exit("$hlds_dir/$key/mapcycle.txt is not writable by the webserver");
         }
           if (!copy("$hlds_dir/$key/savedmapcycles/$savename","$filename")){
            echo "Unable to load $savename to mapcycle.txt"; 
	exit();
      }
    echo "Successfully loaded the saved mapcycle <b>$savename</b> in $hlds_dir/$key/savedmapcycles to $hlds_dir/$key/mapcycle.txt";
    }
    
       //This section handles deleting a previously saved mapcycle
    if ($slaction == delete) {
       if (!is_dir("$hlds_dir/$key/savedmapcycles")){
         exit("Can't find the $hlds_dir/$key/savedmapcycles directory");
         }
       if (!is_writable("$hlds_dir/$key/savedmapcycles")){
         exit("$hlds_dir/$key/savedmapcycles is not writable by the webserver");
         }
          for($i = 0; $i < count($savename); $i++){
	  $line = "$savename[$i]\n";
	  if (!unlink("$hlds_dir/$key/savedmapcycles/$savename[$i]")){
           echo "Error deleting <b>$savename[$i]</b><br>";
           } else {
          echo "Successfully deleted the saved mapcycle <b>$savename[$i]</b> in $hlds_dir/$key/savedmapcycles<br>";
      }
     }
    
    }
 include('../footer.php');
  ?>
  </body>
</html>