<?php
/*
* 06/26/2004 - 23:18:55
*
* writemapcycle.php - This file does all of the write operations to the mapcycle.txt file
* Copyright (C) 2004 Gregory Fowler
* hldstart@gamehound.net
* http://www.gamehound.net/~hldstart/
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
?>
<?php
  #writemapcycle.php
require('../config.php');
include('../chk_login.php');
include('mapheader.php');
$filename = "$hlds_dir/$key/mapcycle.txt";
echo "Writing new mapcycle.txt with the following entries:<br>";
// Let's make sure the file exists and is writable first.
if (is_writable("$hlds_dir/$key/mapcycle.txt"))
  {
     //Make backup the original first
      if (!copy("$filename","$filename.bak"))
       {
           echo "Unable to backup mapcycle.txt before writing"; 
	   exit();
       }
         //This if-else handles wheather to append or overwrite based on user selection
         if ($mode == a)
       {
         if (!$handle = fopen($filename, 'a')) 
         {
           echo "Cannot open file ($filename)";
           exit();
         }
        } else 
               {
                  if (!$handle = fopen($filename, 'w')) 
                  {
                    echo "Cannot open file ($filename)";
                    exit();
                  }
               }
   //This part looks to see if the request is coming from manual_edit.php or fileadmin.php 
    if ($manual == yes)
    {
       //$mapcycle = trim($mapcycle);
       echo "$mapcycle <br>";
       echo "Putting a lock on the file...<br>";
       flock($handle, LOCK_EX);
       fwrite($handle, $mapcycle);
       echo "Unlocking the file...<br>";
       flock($handle, LOCK_UN);
       } else 
              { 
                echo "Putting a lock on the file...<br>";
                flock($handle,LOCK_EX);
                for($i = 0; $i < count($mapcycle); $i++)
                {
	          $line = "$mapcycle[$i]\n";
	          echo "<b>$line</b> <br>";
                  // Write $mapcycle to our opened file.
                  if (fwrite($handle, $line) === FALSE) 
                   {
                     echo "Cannot write to file ($filename)";
                     echo "Unlocking the file...<br>";
                     flock($handle,LOCK_UN);
                     exit();
                    }
                  }
                    echo "Unlocking the file...<br>";
                    flock($handle,LOCK_UN);
                }
             echo "Success, wrote the new entries to file <b>($filename)</b>";
   
            fclose($handle);
                   
   } else
   {
       echo "The file $filename is not writable";
    }
  echo "<br>";
 include('../footer.php');
?>