<?php
/*
* 06/26/2004 - 23:27:42
*
* hlds.php - Forms for setting up the hlds server instance before starting it
* Copyright (C) 2004 Gregory Fowler
* hldstart@gamehound.net
* http://www.gamehound.net/~hldstart/
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
?>
<?php 
   include('config.php');
   include('chk_login.php');
   ?>
<html>
<head>
<title>hldStart Control Panel<?php echo "$vernum";?></title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
</head>
<body bgcolor="#33CCFF" text="#000000">
<p align="right">&nbsp;</p>
<table width="80%" border="0" align="center">
  <tr> 
    <td width="47%"><br> <font size="5">hld<font color="#FF0000"><strong>Start</strong></font> 
      Control Panel <?php echo "$vernum";?></font></td>
    <td width="53%"><div align="right"><font size="5"><a href="http://www.gamehound.net" target="_blank"><img src="<?=$yourlogo?>" alt="Logo" border="0"></a></font></div></td>
  </tr>
</table>
<table width="100%" border="1" align="center">
  <tr>
    <td height="24"><form name="form1" method="post" action="start.php">
        <p align="center"> 
	 	<?php
	         echo '<select name="game" >'; 
                  foreach($games as $key => $value) {
	          echo "<option value=\"$key\">$value</option>";
		}
		echo '</select>';
            ?>
	  <b>Select Map ></b>
          <select name="map" >
	 	<?php
		#This reads the mapcycle.txt of each game listed in the $games array in config.php
	         foreach($games as $key => $value) {
	          echo "<option value=\"$value\">----$value Maps----</option>";
		  $mapcycle = file("$hlds_dir/$key/mapcycle.txt");
                 for($i = 0; $i < count($mapcycle); $i++){
		  $line = $mapcycle[$i];
		  $line = trim($line);
		    echo "<option value=\"$line\">$line</option>\n";
		}
	      }
		echo '</select>';
         
        ?>
	  <b>Select Max Players ></b>
          <select name="max_players" >
            <option value="2" selected>2</option>
            <option value="3">3</option>
            <option value="4">4</option>
            <option value="5">5</option>
            <option value="6">6</option>
            <option value="7">7</option>
            <option value="8">8</option>
            <option value="9">9</option>
            <option value="10">10</option>
            <option value="11">11</option>
            <option value="12">12</option>
            <option value="13">13</option>
            <option value="14">14</option>
            <option value="15">15</option>
            <option value="16">16</option>
            <option value="17">17</option>
            <option value="18">18</option>
            <option value="19">19</option>
            <option value="20">20</option>
            <option value="21">21</option>
            <option value="22">22</option>
            <option value="23">23</option>
            <option value="24">24</option>
            <option value="25">25</option>
            <option value="26">26</option>
            <option value="27">27</option>
            <option value="28">28</option>
            <option value="29">29</option>
            <option value="30">30</option>
            <option value="31">31</option>
            <option value="32">32</option>
          </select>
	 <b>Change port ></b>
          <input name="port" type="text" id="port" value="27015" size="10" maxlength="5">
        </p>
        <p align="center"><b>Select Startup options ></b></p>
        <p align="center">| <a href="help.html">-noipx</a> &gt; 
          <input name="noipx" type="checkbox" id="noipx" value="-noipx">
          | <a href="help.html">-nomaster</a> &gt; 
          <input name="nomaster" type="checkbox" id="nomaster" value="-nomaster">
          | <a href="help.html">-restart</a> &gt; 
          <input name="-restart" type="checkbox" id="-restart" value="checkbox" checked>
          | <a href="help.html">+sv_lan</a> &gt; 
          <input name="+sv_lan" type="checkbox" id="+sv_lan" value="checkbox">
          |<br>
          <br>
          extra parameters(if needed): 
          <input name="params" type="text" id="params">
        </p>
        <p align="center"> 
          <input type="submit" name="Submit" value="Start Server">
        </p>
        <p>&nbsp; </p>
      </form></td>
  </tr>
  <tr> 
  
    <td height="24">
<?php 
echo "<font size=\"1\"> <center> Warning Messages</center></font>";
  for($i = 0; $i < count($framewrk); $i++) {
      $currentfile = $framewrk[$i];
         if (!file_exists($currentfile))
             {
	       echo "<font size=\"1\" color=\"RED\">Warning - missing $currentfile. HldStart requires this file </font><br>";
             //  log_agent("Warning - missing $currentfile")
             } 
	  }
  foreach($games as $key => $value) {
        if (!file_exists("$hlds_dir/$key"))
             {
	       echo "<font size=\"1\" color=\"RED\">Warning - Cannot find $value directory. Is hlds installed at $hlds_dir? </font><br>";
             //  log_agent(Warning - cannot find  $value)
             } 
	  }
  foreach($games as $key => $value) {
        if (!file_exists("$hlds_dir/$key/mapcycle.txt"))
             {
	       echo "<font size=\"1\" color=\"RED\">Warning - Cannot find the mapcycle.txt file in the $value directory. </font><br>";
             } 
	  }
 
    if (!is_dir("$hlds_dir")){
	echo "<font size=\"1\" color=\"RED\">Cannot find $hlds_dir</font>";
     }else{
     if (!file_exists("$hlds_dir/hlds_run")){
	echo "<font size=\"1\" color=\"RED\">Cannot find the hlds_run script</font>";
       }
     }


?>



<div align="center"> </div></td>
  </tr>
</table>
<div align="center"><br>
  <a href="news.php">View News Updates</a> :: <a href="mapadmin/mapadmin.php">MapCycle 
  Admin</a><br>
  <br>
  <?php include('footer.php');?>
</div>
<p>&nbsp;</p><p>&nbsp;</p></body>
</html>